<?php
/*
        Billing for FusionPBX

        Contributor(s):
        Luis Daniel Lucio Quiroz <dlucio@okay.com.mx>
*/

if(defined('STDIN')) {
	$document_root = str_replace("\\", "/", $_SERVER["PHP_SELF"]);
	preg_match("/^(.*)\/app\/.*$/", $document_root, $matches);
	$document_root = $matches[1];
	set_include_path($document_root);
	$_SERVER["DOCUMENT_ROOT"] = $document_root;
	require_once "resources/require.php";
	$display_type = 'text'; //html, text
	$options = getopt("fu:");
	$force = isset($options["f"])?true:false;
	$uuid = isset($options["u"])?$options["u"]:false;
}
else {
	include "root.php";
	require_once "resources/require.php";
	$call_type = 1;
	$force = $_REQUEST['f']?true:false;
	$uuid = $_REQUEST['u']?true:false;
}

if (!function_exists('numeric_version')) {
	function numeric_version() {
		$v = explode('.', software_version());
		$n = ($v[0] * 10000 + $v[1] * 100 + $v[2]);
		return $n;
	}
}

include_once "resources/phpmailer/class.phpmailer.php";
include_once "resources/phpmailer/class.smtp.php";
require_once "app/billing/resources/functions/currency.php";
$debug = (strtolower($_SESSION['billing']['debug']['boolean']) == "true")?true:false;
$domain_uuid = $_SESSION['domain_uuid'];
$domain_name = $_SESSION['domain_name'];

$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

//
$today = getdate();
$invoice_date = date('l jS \of F Y');
$sql_billing = "SELECT * FROM v_billings WHERE credit_type='postpaid' ";

if ($db_type == 'pgsql'){
	$sql_billing .= $force?"":"AND billing_cycle::bigint = ".(int)$today['mday']." ";
}
else{
	$sql_billing .= $force?"":"AND billing_cycle = ".(int)$today['mday']." ";
}

$sql_billing .= $uuid?"AND billing_uuid = '$uuid' ":"";
$sql_billing .= $call_type==1?"AND v_billings.domain_uuid='$domain_uuid'":"";

//$sql_billing = "SELECT * FROM v_billings WHERE billing_cycle = 12";
if ($debug){
        echo $sql_billing; echo "<br />\n";
}
$result_billing = $db->query($sql_billing)->fetchAll(PDO::FETCH_NAMED);
$global_billing_currency = '';
foreach($result_billing as &$billing){
	if ($debug){
		print_r($billing);
	}
	$billing_referred_depth = $billing['referred_depth'];
	$billing_referred_percentage = $billing['referred_percentage'];
	$billing_uuid = $billing['billing_uuid'];
	$billing_currency = $billing['currency'];
	$global_billing_currency = $billing_currency;
	$billing_contact_uuid_to = $billing['contact_uuid_to'];
	$billing_referred_uuid = $billing['referred_by_uuid'];
	$billing_balance = $billing['balance'];

	if ($billing_balance > 0){
		$billing_balance .= ' CR';
	}
	else{
		$billing_balance = abs($billing_balance);
	}
	$smtp['host']           = $_SESSION['email']['smtp_host']['var'];
	$smtp['secure']         = $_SESSION['email']['smtp_secure']['var'];
	$smtp['auth']           = $_SESSION['email']['smtp_auth']['var'];
	$smtp['username']       = $_SESSION['email']['smtp_username']['var'];
	$smtp['password']       = $_SESSION['email']['smtp_password']['var'];
	$smtp['from']           = $_SESSION['email']['smtp_from']['var'];
	$smtp['from_name']      = $_SESSION['email']['smtp_from_name']['var'];
	$smtp['auth']           = ($smtp['auth'] == "true") ? $smtp['auth'] : "false";
	$smtp['password']       = ($smtp['password'] != '') ? $smtp['password'] : null;
	$smtp['secure']         = ($smtp['secure'] != "none") ? $smtp['secure'] : null;
	$smtp['username']       = ($smtp['username'] != '') ? $smtp['username'] : null;        
	$mail = new PHPMailer();
	$mail->IsSMTP();
	$mail->SMTPAuth = $smtp['auth'];
	$mail->Host = $smtp['host'];
        
	if ($smtp['secure'] != '') {
		$mail->SMTPSecure = $smtp['secure'];
	}
        
	if ($smtp['auth'] == 'true') {
		$mail->Username = $smtp['username'];
		$mail->Password = $smtp['password'];
	}
        
	if ($debug){ $mail->SMTPDebug  = 2; };
	$mail->From = $smtp['from'] ;
	$mail->FromName = $smtp['from_name'];
	$mail->addCustomHeader("X-FusionPBX-Billing: $billing_uuid");
	$sql_to = '';
	if (numeric_version() > 30700){
		$sql_to = "SELECT contact_name_given, contact_name_family, email_address as contact_email, contact_organization FROM v_contacts INNER JOIN v_contact_emails USING(contact_uuid) WHERE contact_uuid='$billing_contact_uuid_to' LIMIT 1";
	}
	else{
		$sql_to = "SELECT contact_name_given, contact_name_family, contact_email, contact_organization FROM v_contacts WHERE contact_uuid='$billing_contact_uuid_to'";
	}
	if ($debug){
		echo "sql_to: $sql_to\n";
	}
	$prep_to = $db->prepare($sql_to);
	$prep_to->execute();
	$result_to = $prep_to->fetch(PDO::FETCH_ASSOC);

	$to_email = $result_to["contact_email"];
	$to_contact_name_given = $result_to["contact_name_given"];
	$to_contact_name_family = $result_to["contact_name_family"];
	$to_contact_organization = $result_to["contact_organization"];
	$invoice_number = $_SESSION['billing']['invoice.prefix']['text'];
	$invoice_number .= date ('YmdHis');
	if ($_SESSION['billing']['invoice.first_caracters']['numeric']){
		$invoice_number .= '-'.substr(strtoupper($to_contact_organization), 0, $_SESSION['billing']['invoice.first_caracters']['numeric']);
	}

	$tax_text = ''; $tax_percent = 0;
	$sql_tax = "SELECT description, value FROM v_billing_fixed_charges WHERE currency='%' AND times > 0 AND billing_uuid = '$billing_uuid'";
	$result_tax = $db->query($sql_tax)->fetchAll(PDO::FETCH_NAMED);
	foreach($result_tax as &$tax){
		$tax_text .= ($tax['description'].' ');
		$tax_percent += $tax['value'];
	}

	$tax_percent = number_format($tax_percent, 2);

	if ($tax_percent > 0){
		$total_with_tax = (100 + $tax_percent)/100 * $billing_balance;
		$total_with_tax = number_format($total_with_tax, 2);
	}
	$billing_balance = number_format($billing_balance, 2);

	$image1 = $_SESSION['billing']['invoice.image1']['text'];
	$image2 = $_SESSION['billing']['invoice.image2']['text'];
	$image3 = $_SESSION['billing']['invoice.image3']['text'];

	$body = $_SESSION['billing']['invoice.message']['text'];
	if ($body[0] == '@'){
		$body = file_get_contents(substr($body,1));
	}
	eval("\$body = \"$body\";");

	$subject = $_SESSION['billing']['invoice.subject']['text'];
	if ($subject[0] == '@'){
		$subject = file_get_contents(substr($subject,1));
	}
	eval("\$subject = \"$subject\";");


	if ($debug){
		echo "subject: $subject\n";
		echo "body: $body\n";
		echo "image1: $image1\n";
		echo "image2: $image2\n";
		echo "image3: $image3\n";
	}

	$mail->Subject = $subject;
	$mail->ContentType = "text/html";
	$mail->Body = $body;
	$mail->AddAddress($to_email);

	if (strlen($image1)){
		$mail->AddEmbeddedImage($image1, 'image1');
	}
	if (strlen($image2)){
		$mail->AddEmbeddedImage($image2, 'image2');
	}
	if (strlen($image3)){
		$mail->AddEmbeddedImage($image3, 'image3');
	}

	if (is_array($_SESSION['billing']["invoice.cc"])) {
		foreach($_SESSION['billing']["invoice.cc"] as $cc) {
			$mail->addCC($cc);
		}
	}

	if (is_array($_SESSION['billing']["invoice.bcc"])) {
		foreach($_SESSION['billing']["invoice.bcc"] as $bcc) {
			$mail->addBCC($bcc);
		}
	}

	$mail->Send();
	unset ($mail, $body, $to_contact_name_given, $to_contact_name_family, $refund, $billing_currency);
}

?>
