<?php
/*
        Billing for FusionPBX

        Contributor(s):
        Luis Daniel Lucio Quiroz <dlucio@okay.com.mx>
*/

if(defined('STDIN')) {
	$document_root = str_replace("\\", "/", $_SERVER["PHP_SELF"]);
	preg_match("/^(.*)\/app\/.*$/", $document_root, $matches);
	$document_root = $matches[1];
	set_include_path($document_root);
	$_SERVER["DOCUMENT_ROOT"] = $document_root;
	require_once "resources/require.php";
	$display_type = 'text'; //html, text
}
else {
	include "root.php";
	require_once "resources/require.php";
	$call_type = 1;
}

include_once "resources/phpmailer/class.phpmailer.php";
include_once "resources/phpmailer/class.smtp.php";
require_once "app/billing/resources/functions/currency.php";
$debug = (strtolower($_SESSION['billing']['debug']['boolean']) == "true")?true:false;

$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

//
$today = getdate();
$sql_billing = "SELECT * FROM v_billings WHERE billing_cycle = ".(int)$today['mday'];
//$sql_billing = "SELECT * FROM v_billings WHERE billing_cycle = 12";
if ($debug){
        echo $sql_billing; echo "<br />\n";
}
$result_billing = $db->query($sql_billing)->fetchAll(PDO::FETCH_NAMED);
$global_billing_currency = '';
foreach($result_billing as &$billing){
	if ($debug){
		print_r($billing);
	}
	$billing_referred_depth = $billing['referred_depth'];
	$billing_referred_percentage = $billing['referred_percentage'];
	$billing_uuid = $billing['billing_uuid'];
	$billing_currency = $billing['currency'];
	$global_billing_currency = $billing_currency;
	$billing_contact_uuid_to = $billing['contact_uuid_to'];
	$billing_referred_uuid = $billing['referred_by_uuid'];

	$refund = getRefund($billing_uuid, $billing_referred_depth, $billing_referred_percentage);
	$refund_converted = $refund;
//	$refund_converted = currency_convert($refund, $billing_currency);
	if ($debug){
	        echo "final refund for $billing_referred_uuid: $refund"; echo "<br />\n";
//	        echo "converted refund for $billing_referred_uuid: $refund_converted $billing_currency"; echo "<br />\n";
	}

	$smtp['host']           = $_SESSION['email']['smtp_host']['var'];
	$smtp['secure']         = $_SESSION['email']['smtp_secure']['var'];
	$smtp['auth']           = $_SESSION['email']['smtp_auth']['var'];
	$smtp['username']       = $_SESSION['email']['smtp_username']['var'];
	$smtp['password']       = $_SESSION['email']['smtp_password']['var'];
	$smtp['from']           = $_SESSION['email']['smtp_from']['var'];
	$smtp['from_name']      = $_SESSION['email']['smtp_from_name']['var'];
	$smtp['auth']           = ($smtp['auth'] == "true") ? $smtp['auth'] : "false";
	$smtp['password']       = ($smtp['password'] != '') ? $smtp['password'] : null;
	$smtp['secure']         = ($smtp['secure'] != "none") ? $smtp['secure'] : null;
	$smtp['username']       = ($smtp['username'] != '') ? $smtp['username'] : null;        
	$mail = new PHPMailer();
	$mail->IsSMTP();
	$mail->SMTPAuth = $smtp['auth'];
	$mail->Host = $smtp['host'];
        
	if ($smtp['secure'] != '') {
		$mail->SMTPSecure = $smtp['secure'];
	}
        
	if ($smtp['auth'] == 'true') {
		$mail->Username = $smtp['username'];
		$mail->Password = $smtp['password'];
	}
        
	if ($debug){ $mail->SMTPDebug  = 2; };
	$mail->From = $smtp['from'] ;
	$mail->FromName = $smtp['from_name'];
	$mail->addCustomHeader("X-FusionPBX-Billing: $billing_uuid");
	$mail->Subject = "Aviso de reembolso - Refun notification";


	$sql_to = "SELECT contact_name_given, contact_name_family, contact_email FROM v_contacts WHERE contact_uuid='$billing_contact_uuid_to'";
	if ($debug){
		echo "sql_to: $sql_to\n";
	}
	$prep_to = $db->prepare($sql_to);
	$prep_to->execute();
	$result_to = $prep_to->fetch(PDO::FETCH_ASSOC);

	$to_email = $result_to["contact_email"];
	$to_contact_name_given = $result_to["contact_name_given"];
	$to_contact_name_family = $result_to["contact_name_family"];
	$refund = number_format($refund, 2);

	$body = $_SESSION['billing']['pyramid.message']['text'];
	eval("\$body = \"$body\";");

	if ($debug){
		echo "$body";
	}

	$mail->ContentType = "text/html";
	$mail->Body = $body;
	$mail->AddAddress($to_email);
	$mail->Send();

	unset ($mail, $body, $to_contact_name_given, $to_contact_name_family, $refund, $billing_currency);
}

function getRefund($billing_uuid = '', $billing_referred_depth = 0, $billing_referred_percentage = 0){
	global $db, $debug, $global_billing_currency;

	if ($debug){
	        echo "....................\ngetRefund($billing_uuid, $billing_referred_depth, $billing_referred_percentage)"; echo "<br />\n";
	}

	$refund = 0;

	if ((!is_null($billing_uuid) && $billing_uuid != '') && ($billing_referred_depth > 0)){
		$sql_billing_refer = "SELECT * FROM v_billings WHERE referred_by_uuid='$billing_uuid'";

		if ($debug){
		        echo "sql_billing_refer: $sql_billing_refer"; echo "<br />\n";
		}

		$result_billing_refer = $db->query($sql_billing_refer)->fetchAll(PDO::FETCH_NAMED);
		foreach($result_billing_refer as &$billing_refer){
			// do maths
			$billing_refer_accountcode = $billing_refer['type_value'];
			$billing_reffer_currency = $billing_refer['currency'];
			$sql_sold = "SELECT accountcode, sum(call_sell) AS sold, count(*) AS total_calls FROM v_xml_cdr WHERE accountcode='$billing_refer_accountcode' AND call_sell IS NOT NULL AND accountcode IS NOT NULL AND (start_stamp BETWEEN DATE_SUB(NOW(),  INTERVAL +  1 MONTH) AND NOW())";
			if ($debug){
			        echo "sql_sold: $sql_sold"; echo "<br />\n";
			}

			$prep_statement_sold = $db->prepare($sql_sold);
			$prep_statement_sold->execute();
			$result_sold = $prep_statement_sold->fetch(PDO::FETCH_ASSOC);

			$this_refund = ($result_sold['sold'] * $billing_referred_percentage / 100);
			$this_refund_converted = currency_convert($this_refund, $global_billing_currency);
			$refund += $this_refund_converted;

			if ($debug){
			        echo "this refund: $this_refund"; echo "<br />\n";
			        echo "this converted refund: $this_refund_converted"; echo "<br />\n";
			}

			$billing_refer_uuid = $billing_refer['billing_uuid'];
			$billing_refer_depth = $billing_refer['referred_depth'];
			$billing_refer_percentage = $billing_refer['referred_percentage'];

			$refund += getRefund($billing_refer_uuid, ($billing_referred_depth - 1), $billing_refer_percentage);
		}
	}
			if ($debug){
			        echo "\n\n";
			}
	
	return $refund;
}

?>
